
#include <stdio.h>
#include <string.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#define F_CPU 16000000UL
#include <util/delay.h>

#define DSEND				DDRA
#define DRECEIVE			DDRC
#define ISEND				PINA
#define IRECEIVE			PINC
#define OSEND				PORTA
#define ORECEIVE			PORTC
 
//vectorii pentru determinarea cablului
int STRAIGHT[8]=		{1, 2, 3, 4, 5, 6, 7, 8 };
int CROSS[8]=			{3, 6, 1, 4, 5, 2, 7, 8 };
int ROLLOVER[8]=		{8, 7, 6, 5, 4, 3, 2, 1 };
int TEST[8]=		{0, 0, 0, 0, 0, 0, 0, 0 };

int status = 0;


//determina bitul setat
int getActiveBit(int x) {
	int i;
	
	for(i=0; i<8; i++)
		if(bit_is_set(x, i))
			return i + 1;
	
	return 0;
}

//compara vectorii
int compare(int *a, int *b) {
	int i;
	
	for(i=0; i<8; i++)
		if(a[i]!=b[i])
			return 0;

	return 1;
}

//determina tipul de cablu
void determinCable() {
	if(compare(TEST, STRAIGHT)){
			PORTD=1<<4;
			_delay_ms(2000);
			}
	else 
		if(compare(TEST, CROSS)) {
			 PORTD=1<<5;
			_delay_ms(1000);
			}
	else if(compare(TEST, ROLLOVER)) {
			 PORTD=1<<6;
			_delay_ms(2000);
			}
			
	else {	
			PORTD=1<<8;
			_delay_ms(2000);
			}
	PORTD=0x00;
	
}

//verific daca e un cablu inserat in port
int isCableInserted() {
	int i, r;
	for(i=0; i<8; i++) {
		OSEND = 1<<i;
		r = IRECEIVE;
		
		if(getActiveBit(r) != 0) {
			OSEND=0x00;
			return 1;
		}
	}
	
	return 0;
}

int main() {	
	int i, r;
	char sender[50], receiver[50], aux[5];
	
	DSEND = 0xFF;
	DRECEIVE = 0x00;
	DDRD=0xFF;
	_delay_ms(1000);
	PORTD=0xFF;
	
	strcpy(sender, "");
	strcpy(receiver, "");
	
	do {
		if(isCableInserted()) {
			//trimit semnal la pini
			for(i=0; i<8; i++) {
			
				
				OSEND = 1<<i;
				_delay_ms(500);
				
				//vad pe ce pin am semnal
				r = IRECEIVE;
				
				//retin pinul pe care a venit
				TEST[i] = getActiveBit(r);
				
				//pentru afisare in sender tinem minte pe ce bit am trimis
				sprintf(aux, "%i", i + 1);
				strcat(sender, aux);
				
				if(TEST[i] != 0) {

					sprintf(aux, "%i", TEST[i]);
					
					//avem un cablu conectat
					if(status == 0)
						status = 1;
						
				
				} else sprintf(aux, "-");//fir intrerupt
				
				strcat(receiver, aux);
				
				_delay_ms(300);
			}

			
			OSEND=0x00;
			strcpy(sender, "");
			strcpy(receiver, "");
			
			//tipul de cablu
			if(status == 1) {
				determinCable();
				_delay_ms(3000);
				status = 0;
			}
			
		}
	} while(1);

	return 0;
	
}
